/************************************************************************************/
/*  Program name CAPGLIMP_CALENDAR.sql                                              */
/*  Creater:  WONG Wing Kin (PCCW - UniHub)                                         */
/*************   History   *************************                                */
/* 30 NOV, 2005   WONG Wing Kin         First created                               */
/************************************************************************************/
SET SERVEROUTPUT ON SIZE 1000000;

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPGLIMP_CALENDAR';

	lv_Scc_Count	NUMBER			:=	0;
	lv_Err_Count	NUMBER			:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	CURSOR Cur_F IS
	SELECT
		*
	FROM
		CRST_GL_PERIODS;

	lv_Next_Seq_ID	NUMBER;

BEGIN

	--  RENAME
	UPDATE
		GL_PERIODS
	SET
		PERIOD_SET_NAME	=	CAPBRIMP_MAPPING.RenameStr(SUBSTR(PERIOD_SET_NAME,1,4),PERIOD_SET_NAME)
	WHERE	PERIOD_SET_NAME	IN	(
								SELECT
									PERIOD_SET_NAME
								FROM
									CRST_GL_PERIODS
								);

	FOR C1 IN Cur_F LOOP
		BEGIN
			INSERT INTO CRST_GL_PERIODS_MAP VALUES
			(
			CAPBRIMP_MAPPING.RenameStr(SUBSTR(C1.PERIOD_SET_NAME,1,4),C1.PERIOD_SET_NAME),
			C1.PERIOD_NAME,
			C1.PERIOD_TYPE,
			C1.PERIOD_YEAR,
			C1.PERIOD_NUM,
			C1.PERIOD_SET_NAME,
			C1.PERIOD_NAME,
			C1.PERIOD_TYPE,
			C1.PERIOD_YEAR,
			C1.PERIOD_NUM
			);

			INSERT INTO GL_PERIODS
			VALUES
			(
			C1.PERIOD_SET_NAME,
			C1.PERIOD_NAME,
			C1.LAST_UPDATE_DATE,
			CAPBRIMP_COMMON.GetUser(C1.LAST_UPDATED_BY_NAME),		--LAST_UPDATED_BY,
			C1.START_DATE,
			C1.END_DATE,
			C1.YEAR_START_DATE,
			C1.QUARTER_START_DATE,
			C1.PERIOD_TYPE,
			C1.PERIOD_YEAR,
			C1.PERIOD_NUM,
			C1.QUARTER_NUM,
			C1.ENTERED_PERIOD_NAME,
			C1.ADJUSTMENT_PERIOD_FLAG,
			C1.CREATION_DATE,
			CAPBRIMP_COMMON.GetUser(C1.CREATED_BY_NAME),			--CREATED_BY,
			C1.LAST_UPDATE_LOGIN,
			C1.DESCRIPTION,
			C1.ATTRIBUTE1,
			C1.ATTRIBUTE2,
			C1.ATTRIBUTE3,
			C1.ATTRIBUTE4,
			C1.ATTRIBUTE5,
			C1.ATTRIBUTE6,
			C1.ATTRIBUTE7,
			C1.ATTRIBUTE8,
			C1.CONTEXT
			);
		EXCEPTION
			WHEN OTHERS THEN
				DBMS_OUTPUT.Put_Line(SQLERRM);
				lv_Err_Count	:=	lv_Err_Count + 1;
		END;
		lv_Scc_Count	:=	lv_Scc_Count	+	1;
	END LOOP;

	IF	lv_Err_Count	>	0	THEN
		ROLLBACK;
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/
